Index: /LMDZ4/trunk/libf/dyn3d/leapfrog.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/leapfrog.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/leapfrog.F	(revision 1403)
@@ -15,4 +15,5 @@
       USE guide_mod, ONLY : guide_main
       USE write_field
+      USE control_mod
       IMPLICIT NONE
 
@@ -56,9 +57,8 @@
 #include "logic.h"
 #include "temps.h"
-#include "control.h"
 #include "ener.h"
 #include "description.h"
 #include "serre.h"
-#include "com_io_dyn.h"
+!#include "com_io_dyn.h"
 #include "iniprint.h"
 #include "academic.h"
@@ -197,10 +197,10 @@
 
       itau = 0
-c$$$      iday = day_ini+itau/day_step
-c$$$      time = FLOAT(itau-(iday-day_ini)*day_step)/day_step+time_0
-c$$$         IF(time.GT.1.) THEN
-c$$$          time = time-1.
-c$$$          iday = iday+1
-c$$$         ENDIF
+c      iday = day_ini+itau/day_step
+c      time = REAL(itau-(iday-day_ini)*day_step)/day_step+time_0
+c         IF(time.GT.1.) THEN
+c          time = time-1.
+c          iday = iday+1
+c         ENDIF
 
 
@@ -276,4 +276,5 @@
 
       IF( purmats ) THEN
+      ! Purely Matsuno time stepping
          IF( MOD(itau,iconser) .EQ.0.AND.  forward    ) conser = .TRUE.
          IF( MOD(itau,idissip ).EQ.0.AND..NOT.forward ) apdiss = .TRUE.
@@ -281,8 +282,15 @@
      s          .and. iflag_phys.EQ.1                 ) apphys = .TRUE.
       ELSE
+      ! Leapfrog/Matsuno time stepping 
          IF( MOD(itau   ,iconser) .EQ. 0              ) conser = .TRUE.
          IF( MOD(itau+1,idissip)  .EQ. 0              ) apdiss = .TRUE.
          IF( MOD(itau+1,iphysiq).EQ.0.AND.iflag_phys.EQ.1) apphys=.TRUE.
       END IF
+
+! Ehouarn: for Shallow Water case (ie: 1 vertical layer),
+!          supress dissipation step
+      if (llm.eq.1) then
+        apdiss=.false.
+      endif
 
 c-----------------------------------------------------------------------
@@ -522,10 +530,10 @@
             IF(forward. OR. leapf) THEN
               itau= itau + 1
-c$$$              iday= day_ini+itau/day_step
-c$$$              time= FLOAT(itau-(iday-day_ini)*day_step)/day_step+time_0
-c$$$                IF(time.GT.1.) THEN
-c$$$                  time = time-1.
-c$$$                  iday = iday+1
-c$$$                ENDIF
+c              iday= day_ini+itau/day_step
+c              time= REAL(itau-(iday-day_ini)*day_step)/day_step+time_0
+c                IF(time.GT.1.) THEN
+c                  time = time-1.
+c                  iday = iday+1
+c                ENDIF
             ENDIF
 
@@ -559,12 +567,16 @@
                IF (ok_dynzon) THEN
 #ifdef CPP_IOIPSL
-!                  CALL writedynav(histaveid, itau,vcov ,
-!     ,                 ucov,teta,pk,phi,q,masse,ps,phis)
-                  CALL bilan_dyn (2,dtvr*iperiod,dtvr*day_step*periodav,
-     ,                 ps,masse,pk,pbaru,pbarv,teta,phi,ucov,vcov,q)
+                 CALL bilan_dyn(2,dtvr*iperiod,dtvr*day_step*periodav,
+     &                 ps,masse,pk,pbaru,pbarv,teta,phi,ucov,vcov,q)
 #endif
                END IF
-
-            ENDIF
+               IF (ok_dyn_ave) THEN
+#ifdef CPP_IOIPSL
+                 CALL writedynav(itau,vcov,
+     &                 ucov,teta,pk,phi,q,masse,ps,phis)
+#endif
+               ENDIF
+
+            ENDIF ! of IF((MOD(itau,iperiod).EQ.0).OR.(itau.EQ.itaufin))
 
 c-----------------------------------------------------------------------
@@ -572,7 +584,7 @@
 c   ------------------------------
 
-            IF( MOD(itau,iecri         ).EQ.0) THEN
-c           IF( MOD(itau,iecri*day_step).EQ.0) THEN
-
+            IF( MOD(itau,iecri).EQ.0) THEN
+             ! Ehouarn: output only during LF or Backward Matsuno
+	     if (leapf.or.(.not.leapf.and.(.not.forward))) then
               nbetat = nbetatdem
               CALL geopot(ip1jmp1,teta,pk,pks,phis,phi)
@@ -583,12 +595,19 @@
               enddo
 #ifdef CPP_IOIPSL
-c             CALL writehist(histid,histvid,itau,vcov, 
-c     &                      ucov,teta,phi,q,masse,ps,phis)
+              if (ok_dyn_ins) then
+!               write(lunout,*) "leapfrog: call writehist, itau=",itau
+	       CALL writehist(itau,vcov,ucov,teta,phi,q,masse,ps,phis)
+!               call WriteField('ucov',reshape(ucov,(/iip1,jmp1,llm/)))
+!               call WriteField('vcov',reshape(vcov,(/iip1,jjm,llm/)))
+!              call WriteField('teta',reshape(teta,(/iip1,jmp1,llm/)))
+!               call WriteField('ps',reshape(ps,(/iip1,jmp1/)))
+!               call WriteField('masse',reshape(masse,(/iip1,jmp1,llm/)))
+              endif ! of if (ok_dyn_ins)
 #endif
 ! For some Grads outputs of fields
-             if (output_grads_dyn) then
+              if (output_grads_dyn) then
 #include "write_grads_dyn.h"
-             endif
-
+              endif
+             endif ! of if (leapf.or.(.not.leapf.and.(.not.forward)))
             ENDIF ! of IF(MOD(itau,iecri).EQ.0)
 
@@ -645,11 +664,11 @@
 
              itau =  itau + 1
-c$$$             iday = day_ini+itau/day_step
-c$$$             time = FLOAT(itau-(iday-day_ini)*day_step)/day_step+time_0
-c$$$
-c$$$                  IF(time.GT.1.) THEN
-c$$$                   time = time-1.
-c$$$                   iday = iday+1
-c$$$                  ENDIF
+c             iday = day_ini+itau/day_step
+c             time = REAL(itau-(iday-day_ini)*day_step)/day_step+time_0
+c
+c                  IF(time.GT.1.) THEN
+c                   time = time-1.
+c                   iday = iday+1
+c                  ENDIF
 
                forward =  .FALSE.
@@ -660,5 +679,5 @@
                GO TO 2
 
-            ELSE ! of IF(forward)
+            ELSE ! of IF(forward) i.e. backward step
 
               IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin) THEN
@@ -671,10 +690,14 @@
                IF (ok_dynzon) THEN 
 #ifdef CPP_IOIPSL
-!                  CALL writedynav(histaveid, itau,vcov ,
-!     ,                 ucov,teta,pk,phi,q,masse,ps,phis)
-                  CALL bilan_dyn (2,dtvr*iperiod,dtvr*day_step*periodav,
-     ,                 ps,masse,pk,pbaru,pbarv,teta,phi,ucov,vcov,q)
-#endif
-               END IF
+                 CALL bilan_dyn(2,dtvr*iperiod,dtvr*day_step*periodav,
+     &                 ps,masse,pk,pbaru,pbarv,teta,phi,ucov,vcov,q)
+#endif
+               ENDIF
+               IF (ok_dyn_ave) THEN
+#ifdef CPP_IOIPSL
+                 CALL writedynav(itau,vcov,
+     &                 ucov,teta,pk,phi,q,masse,ps,phis)
+#endif
+               ENDIF
 
               ENDIF ! of IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin)
@@ -690,6 +713,9 @@
                 enddo
 #ifdef CPP_IOIPSL
-c               CALL writehist( histid, histvid, itau,vcov , 
-c    &                           ucov,teta,phi,q,masse,ps,phis)
+              if (ok_dyn_ins) then
+!                write(lunout,*) "leapfrog: call writehist (b)",
+!     &                        itau,iecri
+		CALL writehist(itau,vcov,ucov,teta,phi,q,masse,ps,phis)
+              endif ! of if (ok_dyn_ins)
 #endif
 ! For some Grads outputs
Index: /LMDZ4/trunk/libf/dyn3d/limit_netcdf.F90
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/limit_netcdf.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/limit_netcdf.F90	(revision 1403)
@@ -20,4 +20,5 @@
 !  *    12/2009: D. Cugnet   (f77->f90, calendars, files from coupled runs)
 !-------------------------------------------------------------------------------
+  USE control_mod
 #ifdef CPP_EARTH
   USE dimphy
@@ -27,5 +28,5 @@
                    NF90_DEF_DIM, NF90_DEF_VAR, NF90_PUT_VAR, NF90_PUT_ATT,     &
                    NF90_NOERR,   NF90_NOWRITE, NF90_DOUBLE,  NF90_GLOBAL,      &
-		   NF90_CLOBBER, NF90_ENDDEF,  NF90_UNLIMITED
+		   NF90_CLOBBER, NF90_ENDDEF,  NF90_UNLIMITED, NF90_FLOAT
   USE inter_barxy_m, only: inter_barxy
 #endif
@@ -45,5 +46,4 @@
 !-------------------------------------------------------------------------------
 ! Local variables:
-#include "control.h"
 #include "logic.h"
 #include "comvert.h"
@@ -293,9 +293,9 @@
   USE dimphy, ONLY : klon
   USE phys_state_var_mod, ONLY : pctsrf
+  USE control_mod
   IMPLICIT NONE
 #include "dimensions.h"
 #include "paramet.h"
 #include "comgeom2.h"
-#include "control.h"
 #include "indicesol.h"
 #include "iniprint.h"
Index: /LMDZ4/trunk/libf/dyn3d/ppm3d.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/ppm3d.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/ppm3d.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 
@@ -345,6 +345,6 @@
 C
       PI = 4. * ATAN(1.)
-      DL = 2.*PI / float(IMR)
-      DP =    PI / float(JMR)
+      DL = 2.*PI / REAL(IMR)
+      DP =    PI / REAL(JMR)
 C
       if(IGD.eq.0) then
@@ -388,5 +388,5 @@
       ZTC  = acos(CR1) * (180./PI)
 C
-      JS0 = float(JMR)*(90.-ZTC)/180. + 2
+      JS0 = REAL(JMR)*(90.-ZTC)/180. + 2
       JS0 = max(JS0, J1+1)
       IML = min(6*JS0/(J1-1)+2, 4*IMR/5)
@@ -628,5 +628,5 @@
 C Contribution from the N-S advection
       do i=1,imr*(j2-j1+1)
-      JT = float(J1) - VA(i,j1)
+      JT = REAL(J1) - VA(i,j1)
       wk1(i,j1,2) = VA(i,j1) * (q(i,jt,k,IC) - q(i,jt+1,k,IC))
       enddo
@@ -949,5 +949,5 @@
       IF(IORD.eq.1 .or. j.eq.j1. or. j.eq.j2) THEN
       DO 1406 i=1,IMR
-      iu = float(i) - uc(i,j)
+      iu = REAL(i) - uc(i,j)
 1406  fx1(i) = qtmp(iu)
       ELSE
@@ -957,5 +957,5 @@
       if(IORD.eq.2 .or. j.le.j1vl .or. j.ge.j2vl) then
       DO 1408 i=1,IMR
-      iu = float(i) - uc(i,j)
+      iu = REAL(i) - uc(i,j)
 1408  fx1(i) = qtmp(iu) + DC(iu)*(sign(1.,uc(i,j))-uc(i,j))
       else
@@ -1111,5 +1111,5 @@
       if(JORD.eq.1) then
       DO 1000 i=1,len
-      JT = float(J1) - VC(i,J1)
+      JT = REAL(J1) - VC(i,J1)
 1000  fx(i,j1) = p(i,JT)
       else
@@ -1123,5 +1123,5 @@
       else
       DO 1200 i=1,len
-      JT = float(J1) - VC(i,J1)
+      JT = REAL(J1) - VC(i,J1)
 1200  fx(i,j1) = p(i,JT) + (sign(1.,VC(i,j1))-VC(i,j1))*DC2(i,JT)
       endif
@@ -1358,5 +1358,5 @@
 	do j=j1-1,j2+1
       do i=1,imr
-      JP = float(j)-VA(i,j)
+      JP = REAL(j)-VA(i,j)
       ady(i,j) = VA(i,j)*(wk(i,jp)-wk(i,jp+1))
       enddo
@@ -1582,5 +1582,5 @@
       JMR = JNP-1
       do 55 j=2,JNP
-        ph5  =  -0.5*PI + (FLOAT(J-1)-0.5)*DP
+        ph5  =  -0.5*PI + (REAL(J-1)-0.5)*DP
 55      cose(j) = cos(ph5)
 C
@@ -1834,5 +1834,5 @@
 C
 c      if(first) then
-      DP = 4.*ATAN(1.)/float(JNP-1)
+      DP = 4.*ATAN(1.)/REAL(JNP-1)
       CAP1 = IMR*(1.-COS((j1-1.5)*DP))/DP
 c      first = .false.
@@ -1889,5 +1889,5 @@
 C Check Poles.
       if(q(1,1).lt.0.) then
-      dq = q(1,1)*cap1/float(IMR)*acosp(j1)
+      dq = q(1,1)*cap1/REAL(IMR)*acosp(j1)
       do i=1,imr
       q(i,1) = 0.
@@ -1898,5 +1898,5 @@
 C
       if(q(1,JNP).lt.0.) then
-      dq = q(1,JNP)*cap1/float(IMR)*acosp(j2)
+      dq = q(1,JNP)*cap1/REAL(IMR)*acosp(j2)
       do i=1,imr
       q(i,JNP) = 0.
Index: /LMDZ4/trunk/libf/dyn3d/ran1.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/ran1.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/ran1.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       FUNCTION RAN1(IDUM)
@@ -20,5 +20,5 @@
           IX1=MOD(IA1*IX1+IC1,M1)
           IX2=MOD(IA2*IX2+IC2,M2)
-          R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
+          R(J)=(REAL(IX1)+REAL(IX2)*RM2)*RM1
 11      CONTINUE
         IDUM=1
@@ -30,5 +30,5 @@
       IF(J.GT.97.OR.J.LT.1)PAUSE
       RAN1=R(J)
-      R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
+      R(J)=(REAL(IX1)+REAL(IX2)*RM2)*RM1
       RETURN
       END
Index: /LMDZ4/trunk/libf/dyn3d/sortvarc.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/sortvarc.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/sortvarc.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE sortvarc
@@ -59,5 +59,5 @@
 
        dtvrs1j   = dtvr/daysec
-       rjour     = FLOAT( INT( itau * dtvrs1j ))
+       rjour     = REAL( INT( itau * dtvrs1j ))
        heure     = ( itau*dtvrs1j-rjour ) * 24.
        imjmp1    = iim * jjp1
@@ -129,7 +129,7 @@
       ang   = SSUM(     llm,  angl, 1 )
 
-c      rday = FLOAT(INT ( day_ini + time ))
+c      rday = REAL(INT ( day_ini + time ))
 c
-       rday = FLOAT(INT(time-jD_ref-jH_ref))
+       rday = REAL(INT(time-jD_ref-jH_ref))
       IF(ptot0.eq.0.)  THEN
          PRINT 3500, itau, rday, heure,time
Index: /LMDZ4/trunk/libf/dyn3d/sortvarc0.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/sortvarc0.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/sortvarc0.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE sortvarc0
@@ -60,5 +60,5 @@
 
        dtvrs1j   = dtvr/daysec
-       rjour     = FLOAT( INT( itau * dtvrs1j ))
+       rjour     = REAL( INT( itau * dtvrs1j ))
        heure     = ( itau*dtvrs1j-rjour ) * 24.
        imjmp1    = iim * jjp1
@@ -130,5 +130,5 @@
       ang0   = SSUM(     llm,  angl, 1 )
 
-      rday = FLOAT(INT (time ))
+      rday = REAL(INT (time ))
 c
       PRINT 3500, itau, rday, heure, time
Index: /LMDZ4/trunk/libf/dyn3d/sw_case_williamson91_6.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/sw_case_williamson91_6.F	(revision 1403)
+++ /LMDZ4/trunk/libf/dyn3d/sw_case_williamson91_6.F	(revision 1403)
@@ -0,0 +1,140 @@
+!
+! $Id $
+!
+      SUBROUTINE sw_case_williamson91_6(vcov,ucov,teta,masse,ps)
+
+c=======================================================================
+c
+c   Author:    Thomas Dubos      original: 26/01/2010
+c   -------
+c
+c   Subject:
+c   ------
+c   Realise le cas-test 6 de Williamson et al. (1991) : onde de Rossby-Haurwitz
+c
+c   Method:
+c   --------
+c
+c   Interface:
+c   ----------
+c
+c      Input:
+c      ------
+c
+c      Output:
+c      -------
+c
+c=======================================================================
+      IMPLICIT NONE
+c-----------------------------------------------------------------------
+c   Declararations:
+c   ---------------
+
+#include "dimensions.h"
+#include "paramet.h"
+#include "comvert.h"
+#include "comconst.h"
+#include "comgeom.h"
+#include "iniprint.h"
+
+c   Arguments:
+c   ----------
+
+c   variables dynamiques
+      REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
+      REAL teta(ip1jmp1,llm)                 ! temperature potentielle
+      REAL ps(ip1jmp1)                       ! pression  au sol
+      REAL masse(ip1jmp1,llm)                ! masse d'air
+      REAL phis(ip1jmp1)                     ! geopotentiel au sol
+
+c   Local:
+c   ------
+
+      REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
+      REAL pks(ip1jmp1)                      ! exner au  sol
+      REAL pk(ip1jmp1,llm)                   ! exner au milieu des couches
+      REAL pkf(ip1jmp1,llm)                  ! exner filt.au milieu des couches
+      REAL alpha(ip1jmp1,llm),beta(ip1jmp1,llm)
+
+      REAL :: sinth,costh,costh2, Ath,Bth,Cth, lon,dps
+      INTEGER i,j,ij
+
+      REAL, PARAMETER    :: rho=1 ! masse volumique de l'air (arbitraire)
+      REAL, PARAMETER    :: K    = 7.848e-6  ! K = \omega
+      REAL, PARAMETER    :: gh0  = 9.80616 * 8e3 
+      INTEGER, PARAMETER :: R0=4, R1=R0+1, R2=R0+2         ! mode 4
+c NB : rad = 6371220 dans W91 (6371229 dans LMDZ)
+c      omeg = 7.292e-5 dans W91 (7.2722e-5 dans LMDZ)
+ 
+      IF(0==0) THEN
+c Williamson et al. (1991) : onde de Rossby-Haurwitz
+         teta = preff/rho/cpp
+c geopotentiel (pression de surface)
+         do j=1,jjp1
+            costh2 = cos(rlatu(j))**2
+            Ath = (R0+1)*(costh2**2) + (2*R0*R0-R0-2)*costh2 - 2*R0*R0
+            Ath = .25*(K**2)*(costh2**(R0-1))*Ath
+            Ath = .5*K*(2*omeg+K)*costh2 + Ath 
+            Bth = (R1*R1+1)-R1*R1*costh2
+            Bth = 2*(omeg+K)*K/(R1*R2) * (costh2**(R0/2))*Bth
+            Cth = R1*costh2 - R2
+            Cth = .25*K*K*(costh2**R0)*Cth
+            do i=1,iip1
+               ij=(j-1)*iip1+i
+               lon = rlonv(i)
+               dps = Ath + Bth*cos(R0*lon) + Cth*cos(2*R0*lon)
+               ps(ij) = rho*(gh0 + (rad**2)*dps)
+            enddo
+         enddo
+         write(lunout,*) 'W91 ps', MAXVAL(ps), MINVAL(ps)
+c vitesse zonale ucov
+         do j=1,jjp1
+            costh  = cos(rlatu(j))
+            costh2 = costh**2
+            Ath = rad*K*costh
+            Bth = R0*(1-costh2)-costh2
+            Bth = rad*K*Bth*(costh**(R0-1))
+            do i=1,iip1
+               ij=(j-1)*iip1+i
+               lon = rlonu(i)
+               ucov(ij,1) = (Ath + Bth*cos(R0*lon))
+            enddo
+         enddo
+         write(lunout,*) 'W91 u', MAXVAL(ucov(:,1)), MINVAL(ucov(:,1))
+         ucov(:,1)=ucov(:,1)*cu
+c vitesse meridienne vcov
+         do j=1,jjm
+            sinth  = sin(rlatv(j))
+            costh  = cos(rlatv(j))
+            Ath = -rad*K*R0*sinth*(costh**(R0-1))
+            do i=1,iip1
+               ij=(j-1)*iip1+i
+               lon = rlonv(i)
+               vcov(ij,1) = Ath*sin(R0*lon)
+            enddo
+         enddo
+         write(lunout,*) 'W91 v', MAXVAL(vcov(:,1)), MINVAL(vcov(:,1))
+         vcov(:,1)=vcov(:,1)*cv
+         
+c         ucov=0
+c         vcov=0
+      ELSE
+c test non-tournant, onde se propageant en latitude
+         do j=1,jjp1
+            do i=1,iip1
+               ij=(j-1)*iip1+i
+               ps(ij) = 1e5*(1 + .1*exp(-100*(1+sin(rlatu(j)))**2) )
+            enddo
+         enddo
+         
+c     rho = preff/(cpp*teta)
+         teta = .01*preff/cpp   ! rho = 100 ; phi = ps/rho = 1e3 ; c=30 m/s = 2600 km/j = 23 degres / j
+         ucov=0.
+         vcov=0.
+      END IF      
+      
+      CALL pression ( ip1jmp1, ap, bp, ps, p       )
+      CALL massdair(p,masse)
+
+      END
+c-----------------------------------------------------------------------
Index: /LMDZ4/trunk/libf/dyn3d/tourabs.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/tourabs.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/tourabs.F	(revision 1403)
@@ -57,7 +57,7 @@
         ELSE
          rot( ij,l ) = (vcov(ij+1,l)/cv(ij+1)-vcov(ij,l)/cv(ij))/
-     $                 (2.*pi*RAD*cos(rlatv(j)))*float(iim)
+     $                 (2.*pi*RAD*cos(rlatv(j)))*REAL(iim)
      $                +(ucov(ij+iip1,l)/cu(ij+iip1)-ucov(ij,l)/cu(ij))/
-     $                 (pi*RAD)*(float(jjm)-1.)
+     $                 (pi*RAD)*(REAL(jjm)-1.)
 c
         ENDIF
Index: /LMDZ4/trunk/libf/dyn3d/traceurpole.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/traceurpole.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/traceurpole.F	(revision 1403)
@@ -1,6 +1,8 @@
 !
-! $Header$
+! $Id$
 !
           subroutine traceurpole(q,masse)
+
+      USE control_mod
 
           implicit none
@@ -15,5 +17,4 @@
 #include "logic.h"
 #include "temps.h"
-#include "control.h"
 #include "ener.h"
 #include "description.h"
Index: /LMDZ4/trunk/libf/dyn3d/ugeostr.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/ugeostr.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/ugeostr.F	(revision 1403)
@@ -40,5 +40,5 @@
             DO i=1,iim
                u(i,j,l)=fact*(phi(i,j+1,l)-phi(i,j,l))
-               um(j,l)=um(j,l)+u(i,j,l)/float(iim)
+               um(j,l)=um(j,l)+u(i,j,l)/REAL(iim)
             ENDDO
          ENDDO
Index: /LMDZ4/trunk/libf/dyn3d/write_paramLMDZ_dyn.h
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/write_paramLMDZ_dyn.h	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/write_paramLMDZ_dyn.h	(revision 1403)
@@ -7,41 +7,41 @@
       itau_w=itau_dyn+itau
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(prt_level) 
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(prt_level) 
       CALL histwrite(nid_ctesGCM, "prt_level", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(dayref)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(dayref)
       CALL histwrite(nid_ctesGCM, "dayref", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(anneeref)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(anneeref)
       CALL histwrite(nid_ctesGCM, "anneeref", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(raz_date)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(raz_date)
       CALL histwrite(nid_ctesGCM, "raz_date", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(nday)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(nday)
       CALL histwrite(nid_ctesGCM, "nday", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(day_step)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(day_step)
       CALL histwrite(nid_ctesGCM, "day_step", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(iperiod)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(iperiod)
       CALL histwrite(nid_ctesGCM, "iperiod", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(iapp_tracvl)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(iapp_tracvl)
       CALL histwrite(nid_ctesGCM, "iapp_tracvl", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(iconser)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(iconser)
       CALL histwrite(nid_ctesGCM, "iconser", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(iecri)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(iecri)
       CALL histwrite(nid_ctesGCM, "iecri", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
@@ -51,5 +51,5 @@
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(idissip)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(idissip)
       CALL histwrite(nid_ctesGCM, "idissip", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
@@ -63,13 +63,13 @@
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(nitergdiv)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(nitergdiv)
       CALL histwrite(nid_ctesGCM, "nitergdiv", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(nitergrot)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(nitergrot)
       CALL histwrite(nid_ctesGCM, "nitergrot", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(niterh) 
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(niterh) 
       CALL histwrite(nid_ctesGCM, "niterh", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
@@ -118,9 +118,9 @@
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(iflag_phys)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(iflag_phys)
       CALL histwrite(nid_ctesGCM, "iflag_phys", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
 c
-      zx_tmp_2d(1:iip1,1:jjp1)=FLOAT(iphysiq)
+      zx_tmp_2d(1:iip1,1:jjp1)=REAL(iphysiq)
       CALL histwrite(nid_ctesGCM, "iphysiq", itau_w,
      .               zx_tmp_2d,iip1*jjp1,ndex2d)
Index: /LMDZ4/trunk/libf/dyn3dpar/adaptdt.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/adaptdt.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3dpar/adaptdt.F	(revision 1403)
@@ -1,7 +1,9 @@
 !
-! $Header$
+! $Id$
 !
       subroutine adaptdt(nadv,dtbon,n,pbaru,
      c                   masse)
+
+      USE control_mod
 
       IMPLICIT NONE
@@ -16,5 +18,4 @@
 #include "logic.h"
 #include "temps.h"
-#include "control.h"
 #include "ener.h"
 #include "description.h"
Index: /LMDZ4/trunk/libf/dyn3dpar/advtrac_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/advtrac_p.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3dpar/advtrac_p.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -23,4 +23,5 @@
       USE times
       USE infotrac
+      USE control_mod
       IMPLICIT NONE
 c
@@ -33,5 +34,4 @@
 #include "logic.h"
 #include "temps.h"
-#include "control.h"
 #include "ener.h"
 #include "description.h"
@@ -215,5 +215,5 @@
          ijb=ij_begin
          ije=ij_end
-         flxw(ijb:ije,1:llm)=wg(ijb:ije,1:llm)/FLOAT(iapp_tracvl)
+         flxw(ijb:ije,1:llm)=wg(ijb:ije,1:llm)/REAL(iapp_tracvl)
 
 c  test sur l'eventuelle creation de valeurs negatives de la masse
Index: /LMDZ4/trunk/libf/dyn3dpar/bilan_dyn_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/bilan_dyn_p.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3dpar/bilan_dyn_p.F	(revision 1403)
@@ -511,5 +511,5 @@
      .	                      /masse_cum(:,jjb:jje,:)
       enddo
-      zz=1./float(ncum)
+      zz=1./REAL(ncum)
 
       jjb=jj_begin
Index: /LMDZ4/trunk/libf/dyn3dpar/caladvtrac_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/caladvtrac_p.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3dpar/caladvtrac_p.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -9,4 +9,5 @@
       USE parallel
       USE infotrac
+      USE control_mod
 c
       IMPLICIT NONE
@@ -25,5 +26,4 @@
 #include "paramet.h"
 #include "comconst.h"
-#include "control.h"
 
 c   Arguments:
Index: /LMDZ4/trunk/libf/dyn3dpar/calfis_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/calfis_p.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3dpar/calfis_p.F	(revision 1403)
@@ -34,11 +34,13 @@
       USE dimphy
       USE mod_phys_lmdz_para, mpi_root_xx=>mpi_root 
+      USE mod_interface_dyn_phys
+      USE IOPHY
+#endif
       USE parallel, ONLY : omp_chunk, using_mpi
-      USE mod_interface_dyn_phys
       USE Write_Field
       Use Write_field_p
       USE Times
-      USE IOPHY
       USE infotrac
+      USE control_mod
 
       IMPLICIT NONE
@@ -107,5 +109,5 @@
 #include "comvert.h"
 #include "comgeom2.h"
-#include "control.h"
+#include "iniprint.h"
 #ifdef CPP_MPI
       include 'mpif.h'
@@ -114,6 +116,6 @@
 c    -----------
       LOGICAL  lafin
-      REAL heure
-
+!      REAL heure
+      REAL, intent(in):: jD_cur, jH_cur
       REAL pvcov(iip1,jjm,llm)
       REAL pucov(iip1,jjp1,llm)
@@ -128,4 +130,5 @@
       REAL pdteta(iip1,jjp1,llm)
       REAL pdq(iip1,jjp1,llm,nqtot)
+      REAL flxw(iip1,jjp1,llm)  ! Flux de masse verticale sur la grille dynamique
 c
       REAL pps(iip1,jjp1)
@@ -143,5 +146,5 @@
       REAL clesphy0( longcles )
 
-
+#ifdef CPP_EARTH
 c    Local variables :
 c    -----------------
@@ -180,8 +183,31 @@
       REAL,SAVE,ALLOCATABLE ::  flxwfi_omp(:,:)     ! Flux de masse verticale sur la grille physiq
 
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Introduction du splitting (FH)
+! Question pour Yann :
+! J'ai été surpris au début que les tableaux zufi_omp, zdufi_omp n'co soitent
+! en SAVE. Je crois comprendre que c'est parce que tu voulais qu'il
+! soit allocatable (plutot par exemple que de passer une dimension
+! dépendant du process en argument des routines) et que, du coup,
+! le SAVE évite d'avoir à refaire l'allocation à chaque appel.
+! Tu confirmes ?
+! J'ai suivi le même principe pour les zdufic_omp
+! Mais c'est surement bien que tu controles.
+! 
+
+      REAL,ALLOCATABLE,SAVE :: zdufic_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zdvfic_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zdtfic_omp(:,:)
+      REAL,ALLOCATABLE,SAVE :: zdqfic_omp(:,:,:)
+      REAL jH_cur_split,zdt_split
+      LOGICAL debut_split,lafin_split
+      INTEGER isplit
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
 c$OMP THREADPRIVATE(zplev_omp,zplay_omp,zphi_omp,zphis_omp,
 c$OMP+                 presnivs_omp,zufi_omp,zvfi_omp,ztfi_omp,
 c$OMP+                 zqfi_omp,zdufi_omp,zdvfi_omp,
-c$OMP+                 zdtfi_omp,zdqfi_omp,zdpsrf_omp,flxwfi_omp)       
+c$OMP+                 zdtfi_omp,zdqfi_omp,zdpsrf_omp,flxwfi_omp,
+c$OMP+                 zdufic_omp,zdvfic_omp,zdtfic_omp,zdqfic_omp)       
 
       LOGICAL,SAVE :: first_omp=.true.
@@ -199,5 +225,4 @@
       REAL PVteta(klon,ntetaSTD)
       
-      REAL flxw(iip1,jjp1,llm)  ! Flux de masse verticale sur la grille dynamique
       
       REAL SSUM
@@ -207,5 +232,4 @@
       SAVE firstcal,debut
 c$OMP THREADPRIVATE(firstcal,debut)
-      REAL, intent(in):: jD_cur, jH_cur
       
       REAL,SAVE,dimension(1:iim,1:llm):: du_send,du_recv,dv_send,dv_recv
@@ -235,8 +259,9 @@
         debut = .TRUE.
         IF (ngridmx.NE.2+(jjm-1)*iim) THEN
-         PRINT*,'STOP dans calfis'
-         PRINT*,'La dimension ngridmx doit etre egale a 2 + (jjm-1)*iim'
-         PRINT*,'  ngridmx  jjm   iim   '
-         PRINT*,ngridmx,jjm,iim
+         write(lunout,*) 'STOP dans calfis'
+         write(lunout,*) 
+     &   'La dimension ngridmx doit etre egale a 2 + (jjm-1)*iim'
+         write(lunout,*) '  ngridmx  jjm   iim   '
+         write(lunout,*) ngridmx,jjm,iim
          STOP
         ENDIF
@@ -498,4 +523,8 @@
         allocate(zdtfi_omp(klon,llm))
         allocate(zdqfi_omp(klon,llm,nqtot))
+        allocate(zdufic_omp(klon,llm))
+        allocate(zdvfic_omp(klon,llm))
+        allocate(zdtfic_omp(klon,llm))
+        allocate(zdqfic_omp(klon,llm,nqtot))
         allocate(zdpsrf_omp(klon))
         allocate(flxwfi_omp(klon,llm))
@@ -600,11 +629,28 @@
       if (planet_type=="earth") then
 #ifdef CPP_EARTH
+
+!$OMP MASTER
+      write(lunout,*) 'PHYSIQUE AVEC NSPLIT_PHYS=',nsplit_phys
+!$OMP END MASTER
+      zdt_split=dtphys/nsplit_phys
+      zdufic_omp(:,:)=0.
+      zdvfic_omp(:,:)=0.
+      zdtfic_omp(:,:)=0.
+      zdqfic_omp(:,:,:)=0.
+
+      do isplit=1,nsplit_phys
+
+         jH_cur_split=jH_cur+(isplit-1) * dtvr / (daysec *nsplit_phys)
+         debut_split=debut.and.isplit==1
+         lafin_split=lafin.and.isplit==nsplit_phys
+
+
       CALL physiq (klon,
      .             llm,
-     .             debut,
-     .             lafin,
+     .             debut_split,
+     .             lafin_split,
      .             jD_cur,
-     .             jH_cur,
-     .             dtphys,
+     .             jH_cur_split,
+     .             zdt_split,
      .             zplev_omp,
      .             zplay_omp,
@@ -628,4 +674,22 @@
      .             pducov,
      .             PVteta)
+
+         zufi_omp(:,:)=zufi_omp(:,:)+zdufi_omp(:,:)*zdt_split
+         zvfi_omp(:,:)=zvfi_omp(:,:)+zdvfi_omp(:,:)*zdt_split
+         ztfi_omp(:,:)=ztfi_omp(:,:)+zdtfi_omp(:,:)*zdt_split
+         zqfi_omp(:,:,:)=zqfi_omp(:,:,:)+zdqfi_omp(:,:,:)*zdt_split
+
+         zdufic_omp(:,:)=zdufic_omp(:,:)+zdufi_omp(:,:)
+         zdvfic_omp(:,:)=zdvfic_omp(:,:)+zdvfi_omp(:,:)
+         zdtfic_omp(:,:)=zdtfic_omp(:,:)+zdtfi_omp(:,:)
+         zdqfic_omp(:,:,:)=zdqfic_omp(:,:,:)+zdqfi_omp(:,:,:)
+
+      enddo
+
+      zdufi_omp(:,:)=zdufic_omp(:,:)/nsplit_phys
+      zdvfi_omp(:,:)=zdvfic_omp(:,:)/nsplit_phys
+      zdtfi_omp(:,:)=zdtfic_omp(:,:)/nsplit_phys
+      zdqfi_omp(:,:,:)=zdqfic_omp(:,:,:)/nsplit_phys
+
 #endif
       endif !of if (planet_type=="earth")
@@ -1047,5 +1111,6 @@
 
 #else
-      write(*,*) "calfis_p: for now can only work with parallel physics"
+      write(lunout,*)
+     & "calfis_p: for now can only work with parallel physics"
       stop
 #endif
